IntFactorDom< MyRandIter > Class Template Referenceabstract

Integer Factor Domain. More...

`#include <givintfactor.h>`

Inheritance diagram for IntFactorDom< MyRandIter >:
[legend]
Collaboration diagram for IntFactorDom< MyRandIter >:
[legend]

## Public Member Functions

template<class Container1, class Container2>
bool | set (Container1 &setint, Container2 &setpwd, const Rep &a, unsigned long loops=0) const
| Factors with primes.
Rep & | Erathostene (Rep &, const Rep &p) const
| returns a small factor
bool | isUnit (const Rep &x) const
| isUnit
bool | isDivisor (const Element &a, const Element &b) const
| isDivisor (a, b) Test if b | a.
Arithmetic Operations
The first argument is set and is also the return value.
Element & | mul (Element &x, const Element &y, const Element &z) const
| x := y*z
Element & | div (Element &x, const Element &y, const Element &z) const
| x := y/z
Element & | mod (Element &x, const Element &y, const Element &z) const
| x := y mod z
Element & | add (Element &x, const Element &y, const Element &z) const
| x := y + z
Element & | sub (Element &x, const Element &y, const Element &z) const
| x := y - z
Element & | axpy (Element &z, const Element &a, const Element &x, const Element &y) const
| z := a*x + y
Element & | maxpy (Element &z, const Element &a, const Element &x, const Element &y) const
| z := y - a*x
Element & | maxpyin (Element &z, const Element &a, const Element &x) const
| z := z - a*x
Element & | axmy (Element &z, const Element &a, const Element &x, const Element &y) const
| z := a*x - y
Element & | axpyin (Element &z, const Element &a, const Element &x) const
| z := a*x + z
Element & | axmyin (Element &z, const Element &a, const Element &x) const
| z := a*x - z
Element & | neg (Element &x, const Element &y) const
| x := -y
Element & | inv (Element &x, const Element &y) const
| x := 1/y
Inplace Arithmetic Operations
The first argument is modified and the result is the return value.
Element & | mulin (Element &x, const Element &y) const
| x := x*y
Element & | divin (Element &x, const Element &y) const
| x := x/y
Element & | modin (Element &x, const Element &y) const
| x := x mod y
Element & | addin (Element &x, const Element &y) const
| x := x + y
Element & | subin (Element &x, const Element &y) const
| x := x - y
Element & | negin (Element &x) const
| x := -x
Element & | invin (Element &x) const
| x := 1/x
Comparison Predicates
bool | areEqual (const Element &x, const Element &y) const
| x == y
Input/Output Operations
std::istream & | read (std::istream &is) const
| Read field.
virtual std::istream & | read (std::istream &is, Element &x) const
| Read field element.
std::ostream & | write (std::ostream &os, std::string F) const
| Read field.
std::ostream & | write (std::ostream &os, const Element &x) const
| Print field element.
Data Object Management.
first argument is set and the value is also returned.

## Detailed Description

template<class MyRandIter = GivRandom>
class Givaro::IntFactorDom< MyRandIter >

Integer Factor Domain.

Examples
  examples/Integer/ProbLucas.C, examples/Integer/ifactor.C, and examples/Integer/ifactor_lenstra.C.

## Member Function Documentation

## read() [1/2]

template<class _Element>

std::istream & read | ( | std::istream & | is | ) | const

inline inherited

Read field.

Returns
  input stream from which field is read.

Parameters

  is | input stream from which field is read.

## read() [2/2]

template<class _Element>

virtual std::istream & read | ( | std::istream & | is,
|  | Element & | x ) const

inline virtual inherited

Read field element.

Returns
  input stream from which field element is read.

Parameters

  is | input stream from which field element is read.
  x | field element.

## write() [1/2]

template<class _Element>

std::ostream & write | ( | std::ostream & | os,
|  | std::string | F ) const

inline inherited

Read field.

Returns
  input stream from which field is read.

Parameters

  is | input stream from which field is read.

## write() [2/2]

template<class _Element>

std::ostream & write | ( | std::ostream & | os,
|  | const Element & | x ) const

inline inherited

Print field element.

Returns
  output stream to which field element is written.

Parameters

  os | output stream to which field element is written.
  x | field element.

The documentation for this class was generated from the following files:

- givintfactor.h
- givintfactor.inl